<?php
/**
 * conceptERP Zarafa-Plugin
 *
 * Changed by: Maik Unruh mm-concept
 * Based on Z-Merge Archive Plugin by Sebastian Kummer <s.kummer@zarafa.com>
 *
 */

class Pluginconcepterp extends Plugin {

function Pluginconcepterp(){}

    function init(){
        // include generated css and js files with the configured parameters
        $this->registerHook('server.main.include.cssfiles');
        $this->registerHook('server.main.include.jsfiles');
        // trigger the entire execute event for maillistmodule
        $this->registerHook('server.module.maillistmodule.execute.before');
    }

    function execute($eventID, &$data){
        switch($eventID)
        {
            case "server.main.include.cssfiles":
                $this->includeCSS($data);
                break;
            case "server.main.include.jsfiles":
                $this->includeJS($data);
                break;
            case "server.module.maillistmodule.execute.before":
                $this->mailListModuleExecute($data['moduleObject']);
                break;

        }
    }

    // include a generated CSS version for the configuration
    function includeCSS(&$data) {
        $data['files'][] = PATH_PLUGIN_DIR."/concepterp/concepterp.config.css.php";
    }

    // include a generated JS version of the configuration
    function includeJS(&$data) {
        $data['files'][] = PATH_PLUGIN_DIR."/concepterp/concepterp.config.js.php";
    }

    // triggered on maillistmodule->execute - works with complete maillistmodule object 
    function mailListModuleExecute(&$maillist) {
        foreach($maillist->data as $action)
        {
            if(isset($action["attributes"]) && isset($action["attributes"]["type"])) {
                $store = $maillist->getActionStore($action);
                $parententryid = $maillist->getActionParentEntryID($action);
                $entryid = $maillist->getActionEntryID($action);
            
                switch($action["attributes"]["type"])
                {
                    case "concepterpSendMail":
                        $result = $this->sendMail($maillist, $store, $parententryid, $entryid, $action);
                        break;
                }
            }
        }
    }


    // reads the RFC822 message from MAPI and submits it to the configured profile
    function sendMail(&$maillist, $store, $parententryid, $entryid, $action) {

        if( (!isset($action["profile"])) || 
            (!isset($GLOBALS['pluginconfig']['concepterp']['profiles'][$action["profile"]]))) 
            return;

        // build a connection manager from config                    
        $profilename = $action["profile"];
        $profile = $GLOBALS['pluginconfig']['concepterp']['profiles'][$profilename];

        // use z-merge authentication libs
        $classname = $profile['authClass'];

        // cancel if it's not possible to read the RFC822 directly from PHP-MAPI or the connector class doesn't exist
        if (!function_exists("mapi_inetmapi_imtoinet")) {
            $response = array("status" => "failed");
            $response["message"]= dgettext('plugin_concepterp', "This version of Zarafa doesn't support this functionality.");

            $response["attributes"] = array("type" => "archiveResponse");
            array_push($maillist->responseData["action"], $response);
            $GLOBALS["bus"]->addData($maillist->responseData);
            return true;
        }

        // get message and addressbook         
        $message = mapi_msgstore_openentry($store, $entryid);
        $addrBook = mapi_openaddressbook($GLOBALS["mapisession"]->getSession());

        // open stream
        $stream = mapi_inetmapi_imtoinet($GLOBALS["mapisession"]->getSession(), $addrBook, $message, array());

        // try to load existing session information for this profile
        $saved_session = $this->getData($profilename);
        if (!is_array($saved_session)) $saved_session = array();

        // instantiate the authentication class
        $authClass = new $classname($profile, $saved_session);

        // build data 
	$moreData = array(
			"zarafauser" => $profile['username'],
			"zarafapasswd" => md5($profile['password']),
                        "user" => $GLOBALS["mapisession"]->getUserName(),
                        "archivefile" => bin2hex($parententryid) . "&" . bin2hex($entryid),
                    );

        // upload file
        $response = $authClass->uploadData($profile['archiveUri'], $stream, "archivefile.txt", "message/rfc822", $moreData);

        // save existing session information for this profile
        if ($authClass->isSessionValid())
            $this->setData($profilename, $authClass->getSessionData());

        if (isset($response['message'])) $response['message'] = dgettext('plugin_concepterp', $response['message']);

        $response["attributes"] = array("type" => "archiveResponse");
        array_push($maillist->responseData["action"], $response);
        $GLOBALS["bus"]->addData($maillist->responseData);
    }
}
?>
